import { upload, boards } from '.'
import { PortFilters } from './Serial'

document.addEventListener('DOMContentLoaded', () => {
  document.querySelectorAll('[arduino-uploader]').forEach((el) => {
    el.addEventListener('click', async () => {
      if (!navigator.serial) return alert('Please enable the Web Serial API first: https://web.dev/serial/#use')
      const hexHref = el.getAttribute('hex-href')
      const board = el.getAttribute('board')
      const verify = el.hasAttribute('verify')
      const progressEl = el.querySelector('.upload-progress')
      const onProgress = (progress: number) => {
        progressEl.innerHTML = `${progress}%`
      }
      var Status = '';
      let portFilters = {} as PortFilters
      try {
        portFilters = { filters: JSON.parse(el.getAttribute('port-filters')) || [] }
      } catch (e) { }
      try {
        await upload(boards['nano'], hexHref, onProgress, verify, portFilters)
      } catch (e) {
        Status = 'Error: can\'t connect to the module. Please see troubleshooting section.<br /><code>' + e + '</code>'
        //alert(e)
        //throw e 
      }
      if (Status.includes('Error: ')) {
        Status = ''
        try {
          await upload(boards['nanoOldBootloader'], hexHref, onProgress, verify, portFilters)
        } catch (e) {
          Status = 'Error: can\'t connect to the module. Please see troubleshooting section.<br /><code>Old Bootloader: ' + e + '</code>'
          //alert(e)
          //throw e //Error: Sending 3020: receiveData timeout after 400ms
        }
      }
      if (Status == '') {
        Status = 'Done!'
      }
      progressEl.innerHTML = Status
      console.log("Upload successful!\nEnvious? here's how https://github.com/dbuezas/arduino-web-uploader")
    })
  })
})
